#ifndef SDES_H
#define SDES_H

#include "bitarray.h"

#define M_ENCRYPT 0x00
#define M_DECRYPT 0x01

BitArray permute10(BitArray b);
BitArray permute8(BitArray b);
BitArray permute4(BitArray b1, BitArray b2);
BitArray exp_permute(BitArray b);
BitArray ip(BitArray b);
BitArray inv_ip(BitArray b);
BitArray _xor(BitArray a, BitArray b);
BitArray sX(int m, BitArray b);
BitArray f(BitArray R, BitArray key);
BitArray fk(BitArray L, BitArray R,BitArray key);
BitArray _crypt(int method, BitArray p_text, BitArray key);

#endif // SDES_H
